routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', ['as' => 'home', 'uses' => 'PagesController@home'])->middleware('example');

/*Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');*/

DB::listen(function($query) {
	echo "<pre>{$query->sql}-{$query->time}</pre>";
});

Route::get('/', ['as' => 'home', 'uses' => 'PagesController@home']);

Route::get('saludos/{nombre?}', ['as' => 'saludos', 'uses' => 'PagesController@saludo'])->where('nombre', "[A-Za-z]+");

Route::resource('mensajes', 'MessagesController');
Route::resource('usuarios', 'UsersController');
Route::get('roles', function() {
	return \App\Role::with('user')->get();
});

Route::get('login', ['as' => 'login', 'uses' => 'Auth\LoginController@showLoginForm']);
Route::post('login', 'Auth\LoginController@login');
Route::get('logout', 'Auth\LoginController@logout');

/*Route::get('test', function() {
	$user = new App\User;
	$user->name = 'Jesus Roncal';
	$user->email = 'jesusroncal94@gmail.com';
	$user->password = bcrypt('123123');
	$user->save();

	return $user;
});


//Route::get('contactos', ['as' => 'contactos', 'uses' => 'PagesController@contact']);

//Route::post('contacto', 'PagesController@mensajes');

/*Route::get('mensajes', ['as' => 'messages.index', 'uses' => 'MessagesController@index']);
Route::get('mensajes/create', ['as' => 'messages.create', 'uses' => 'MessagesController@create']);
Route::post('mensajes', ['as' => 'messages.store', 'uses' => 'MessagesController@store']);
Route::get('mensajes/{id}', ['as' => 'messages.show', 'uses' => 'MessagesController@show']);
Route::get('mensajes/{id}/edit', ['as' => 'messages.edit', 'uses' => 'MessagesController@edit']);
Route::put('mensajes/{id}', ['as' => 'messages.update', 'uses' => 'MessagesController@update']);
Route::delete('mensajes/{id}', ['as' => 'messages.destroy', 'uses' => 'MessagesController@destroy']);*/

app/Message.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Message extends Model
{
	protected $table = 'messages';
	protected $fillable = ['nombre', 'email', 'mensaje', 'user_id'];

	public function user()
	{
		return $this->belongsTo(User::class);
	}

	public function note()
	{
		return $this->morphOne(Note::class, 'notable');
	}

	public function tags()
	{
		return $this->morphToMany(Tag::class, 'taggable')->withTimestamps();
	}
}

app/Http/Controllers/MessagesController.php
<?php

namespace App\Http\Controllers;

use App\Message;
use App\Note;
use App\Tag;
use DB;
use Mail;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Database\Eloquent\Model;
use App\Http\Requests\CreateMessageRequest;

class MessagesController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth', ['except' => ['create', 'store']]);
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //$messages = DB::table('messages')->get();
        $messages = Message::with(['user', 'note', 'tags'])->get();

        return view('messages.index', compact('messages'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('messages.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(CreateMessageRequest $request)
    {
        /*DB::table('messages')->insert([
            "nombre" => $request->input('nombre'),
            "email" => $request->input('email'),
            "mensaje" => $request->input('mensaje'),
            "created_at" => Carbon::now(),
            "updated_at" => Carbon::now(),
        ]);*/

        /*$message = new Message;
        $message->nombre = $request->input('nombre');
        $message->email = $request->input('email');
        $message->mensaje = $request->input('mensaje');
        $message->save();*/

        //dd($request->all());
        //Model::unguard();

        $message = Message::create($request->all());

        Mail::send('emails.contact', ['msg' => $message], function($m) use($message)
        {
            $m->to($message->email, $message->nombre)->subject('Tu mensaje fue recibido');
        });

        return redirect()->route('mensajes.create')->with('info', 'Hemos recibido tu mensaje.');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //$message = DB::table('messages')->where('id', $id)->first();
        $message = Message::findOrFail($id);

        return view('messages.show', compact('message'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //$message = DB::table('messages')->where('id', $id)->first();
        $message = Message::findOrFail($id);
        $tags = Tag::pluck('name', 'id');

        return view('messages.edit', compact('message', 'tags'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

    public function returnFalse()
    {
        return 0;
    }

    public function update(CreateMessageRequest $request, $id)
    {
        try {
            DB::beginTransaction();
                $message = Message::with('note')->findOrFail($id);

                (
                    Note::whereHasMorph('notable', [Message::class], function($query) use($message) {
                        $query->where('notable_id', isset($message->note->notable_id) ? $message->note->notable_id : 0);
                    })->count()
                )
                ?
                    $message->note()->update(['body' => $request->note])

                :
                    $message->note()->create(['body' => $request->note]);

                $message->update($request->only('nombre', 'email', 'mensaje'));
                $message->tags()->sync($request->tags);
                /*($message->note()->update(['body' => $request->note]) === 0)
                    ? $message->note()->create(['body' => $request->note]) : '';*/
            DB::commit();
        } catch (Exception $e) {
            DB::rollback();
        }

        return redirect()->route('mensajes.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //DB::table('messages')->where('id', $id)->delete();
        $message = Message::findOrFail($id);
        $message->note()->delete();
        $message->delete();

        return redirect()->route('mensajes.index');    }
    }

resources/views/messages/create.blade.php
@extends('layout')


@section('contenido')

<h1>Contactos</h1>

<h2>Escríbeme</h2>
@if(session()->has('info'))
	<h3>{{ session('info') }}</h3>
@else
<form method="POST" action="{{ route('mensajes.store') }}">
	
	@include('messages.form', [
		'message' => new App\Message,
		'showFields' => auth()->guest(),
		'showEditFields' => false,
		'btnText' => 'Enviar'
	])

</form>
@endif

@stop

resources/views/messages/edit.blade.php
@extends('layout')

@section('contenido')

<h1>Editar mensaje</h1>

<form method="POST" action="{{ route('mensajes.update', $message->id) }}">
	{!! method_field('PUT') !!}
	
	@include('messages.form', [
		'showFields' => !$message->user_id,
		'showEditFields' => true,
		'btnText' => 'Actualizar'
	])

</form>

@stop

resources/views/messages/form.blade.php
<input type="hidden" name="_token" value="{{ csrf_token() }}">
{!! csrf_field() !!}
<input type="hidden" name="user_id" value="{{ (auth()->check()) ? auth()->user()->id : null }}">

@if($showFields)
	<p><label for="nombre">
		Nombre
		<input class="form-control" type="text" name="nombre" value="{{ isset($message->nombre) ? $message->nombre : old('nombre') }}">
		{!! $errors->first('nombre', '<div class="alert alert-warning" role="alert">:message</div>') !!}
	</label></p>

	<p><label for="email">
		Email
		<input class="form-control" type="email" name="email" value="{{ isset($message->email) ? $message->email : old('email') }}">
		{!! $errors->first('email', '<div class="alert alert-warning" role="alert">:message</div>') !!}
	</label></p>
@endif

<p><label for="mensaje">
	Mensaje
	<textarea class="form-control" name="mensaje">{{ isset($message->mensaje) ? $message->mensaje : old('mensaje') }}</textarea>
	{!! $errors->first('mensaje', '<div class="alert alert-warning" role="alert">:message</div>') !!}
</label></p>

@if($showEditFields)
	<p><label for="note">
		Nota
		<input class="form-control" type="text" name="note" value="{{ isset($message->note->body) ? $message->note->body : '' }}">
	</label></p>

	<div class="checkbox">
		@foreach($tags as $id => $name)
			<label for="tags">
				<input
					type="checkbox"
					value="{{ $id }}"
					{{ $message->tags->pluck('id')->contains($id) ? 'checked' : ''}}
					name="tags[]">
				{{ $name }}
			</label>
		@endforeach
	</div>
	{!! $errors->first('tags', '<div class="alert alert-danger" role="alert">:message</div>') !!}
@endif

<input class="btn btn-primary" type="submit" value="{{ $btnText }}">

resources/views/messages/index.blade.php
@extends('layout')

@section('contenido')

<h1>Todos los mensajes</h1>

<table width="100%" class="table">
	<thead>
		<tr>
			<th>ID</th>
			<th>Nombre</th>
			<th>Email</th>
			<th>Mensaje</th>
			<th>Notas</th>
			<th>Etiquetas</th>
			<th>Acciones</th>
		</tr>
	</thead>
	<tbody>
		@foreach($messages as $message)
			<tr>
				<td>{{ $message->id }}</td>

				@if($message->user_id)
					<td>
						<a href="{{ route('usuarios.show', $message->user_id) }}">{{ $message->user->name }}</a>
					</td>
					<td>{{ $message->user->email }}</td>
				@else
					<td>{{ $message->nombre }}</td>
					<td>{{ $message->email }}</td>
				@endif

				<td>
					<a href="{{ route('mensajes.show', $message->id) }}">{{ $message->mensaje }}</a>
				</td>
				<td>{{ isset($message->note->body) ? $message->note->body : '' }}</td>
				<td>{{ isset($message->tags) ? $message->tags->pluck('name')->implode(', ') : ''}}</td>
				<td>
					<a class="btn btn-primary btn-sm" href="{{ route('mensajes.edit', $message->id) }}">Editar</a>
					<form style="display: inline;" method="POST" action="{{ route('mensajes.destroy', $message->id) }}">
						{!! method_field('DELETE') !!}
						{!! csrf_field() !!}

						<button class="btn btn-danger btn-sm" type="submit">Eliminar</button>
					</form>
				</td>
			</tr>
		@endforeach
	</tbody>
</table>

@stop

resources/views/messages/show.blade.php
@extends('layout')

@section('contenido')

<h1>Mensaje</h1>

@if($message->user_id)
	<p>Enviado por {{ $message->user->name }} - {{ $message->user->email }}</p>
@else
	<p>Enviado por {{ $message->nombre }} - {{ $message->email }}</p>
@endif

<p>{{ $message->mensaje }}</p>

@stop